/*
 *  send_read3.c
 *
 *  v 0.0 2011.05.18 by Golden Wang
 *
 *  open VCOM port, send and receive test message from ttyVCOM0
 *
 *  History
 *
 *  v 0.0 2011.05.18 by Golden Wang
 *    create, ... ok, i keep this as simple as possible
 */

// #define I7K_DEBUG
#include "msw.h"
#include "i7k.h"
#include "i7000.h"

#define RCVBUF_SIZE 16
#define VCOM_CMD_SET_BAUD 2

int main()
{
	int fd,rs;						/* file descriptor */
	char *cmd;					/* point to command string */
	char rbuf[RCVBUF_SIZE];		/* receive buffer */
	__tod_t texp;				/* to receive the expended time */
	int comport = 0;	/* minor 0 = /dev/ttyVCOM0 */
	int timeout = 0;
	ixvcom_cmd_t vcom;
	WORD wT;

	rs = Open_Com(comport, 115200, Data8Bit, NonParity, OneStopBit);

	if (rs > 0) 
	{
		printf("open port failed!\n");
		return -1;
	}

	/* Get vxcomm.exe version */
	sprintf(vcom.cmd, "%s", "01");
	Send_Receive_IXVCOM_Cmd(comport, &vcom);
	printf("VxComm.exe Version : %s\n",vcom.rsbuf);

	/* Get Remote Module's Name */
	sprintf(vcom.cmd, "%s", "10");
	Send_Receive_IXVCOM_Cmd(comport, &vcom);
	printf("Module's Name : %s\n",vcom.rsbuf);

	/*Change Baud Rate */
	sprintf(vcom.cmd, "%s", "021115200");
	Send_Receive_IXVCOM_Cmd(comport, &vcom);
	printf("Change Module's Baud : %s\n",vcom.rsbuf);

	Close_Com(comport);

	return 0;
}
