#include "utility.h"
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <stdlib.h>

int minor[256];
char *tmptty, *tmpcout;
int idx;
int dataport, cmdport;
char scope_id_s[20];

char* concate(char *str, char *c, char *ret)
{
    memset(ret, '\0', 20);
    sprintf(ret, "%s%s", str, c);
    return;
}


int getMinor()
{
    int i, j;

    for (i=0; i<256; i++)
    {
        for (j=0; j<idx; j++)
        {
            if (i == minor[j])
            {
                break;
            }
        }
        if (j == idx)
        {
            minor[idx++] = i;
            return i;
        }
    }
    if (i >= 256)
    {
        return -1;
    }
}

int check_usage(int arg, char *argv[])
{
	int i;
	char buf[10];
	int scope_id;

	if(arg > 2)
	{
		if((strncmp(argv[1], "fe80", 4) == 0) || (strncmp(argv[1], "FE80", 4) == 0) || (strncmp(argv[1], "Fe80", 4) == 0) || (strncmp(argv[1], "fE80", 4) == 0))
		{	
			scope_id = 1;
		}
		else
		{
			scope_id = 0;
		}	
	}

	if (arg == 3+scope_id)
	{
		dataport = 10001;
		cmdport = 10000;

		if(scope_id)
		{
			strcpy(scope_id_s, argv[3]);
		}
	}
	else
	{
		printf("usage: ./addserver [ip] [totalport]\n");
		printf("[ip]\n");
		printf("\tRemote Server IP Address or Domain Name\n\n");
		printf("[totalport]\n");
		printf("\tTotal number of the ports of server\n\n");
		printf("Example:\n");
		printf("\t#./addserver 192.168.0.1 8\n\n");

		return FAILURE;
	}

	return SUCCESS;
}

int main(int arg, char *argv[])
{
	int i, j;
	int total, len, overwrite, fifo, mn, ssl;
	int ttymajor, calloutmajor;
	char c;
	char *tmpstr, *tmp1, *tmp2;
	char tmpm[10], tmpt[40], tmpc[40], major[40];
	char ip[40];
	char ip_buf[40];
	struct in_addr addr;
	unsigned long ipaddr;
	FILE *f, *ft, *frc, *fos;
	char *os = "linux";

	overwrite = -1;
	system("clear");

	if (check_usage(arg, argv) != SUCCESS)
	{
		return FAILURE;
	}

	printf("\nAdding Remote Server...\n\n");

	memset(ip, '\0', 40);

	if(strlen(argv[1]) > 39)
	{
		printf("The server name length error!\n\n");
		return FAILURE;
	}

	sprintf(ip, "%s", argv[1]);

	if (strcmp(ip, "255.255.255.255") == 0)
	{
		printf("Invalid IP Address!\n\n");
		return FAILURE;
	}

	tmpstr = (char *)malloc(256);
	len = 256;
	tmp1 = (char *)malloc(40);
	tmp2 = (char *)malloc(40);
	tmptty = (char *)malloc(2560);
	tmpcout = (char *)malloc(2560);

	memset(minor, -1, sizeof(int)*256);
	idx = 0;

	/* get OS */
	fos = fopen ("/etc/redhat-release", "r");

	if (fos != NULL)
	{
		fclose(fos);
		os = "linux";
	}
	else
	{
		fos = fopen ("/etc/SuSE-release", "r");

		if (fos != NULL)
		{
			fclose(fos);
			os = "SuSE";
		}
		else
		{
			fos = fopen ("/etc/debian_version", "r");

			if (fos != NULL)
			{
				fclose(fos);
				os = "debian";
			}
			else
			{
				fos = fopen ("/etc/gentoo-release", "r");

				if (fos != NULL)
				{
					fclose(fos);
					os = "gentoo";
				}
			}
		}
	}

	sprintf(tmpstr, "%s/ixvcomd.cf", VCOMPATH);

	f = fopen (tmpstr, "r");

	if (f == NULL)
	{
		printf("file open error_3\n");
		free(tmpstr);
		free(tmp1);
		free(tmp2);
		free(tmptty);
		free(tmpcout);

		return FAILURE;
	}

	ft = fopen ("/tmp/ixvcom_tmpfile2", "w");

	if (ft == NULL)
	{
		printf("tmpfile open error\n");
		free(tmpstr);
		free(tmp1);
		free(tmp2);
		free(tmptty);
		free(tmpcout);
		return(0);
	}

	for (;;)
	{
		/* end of file */
		if (getline (&tmpstr, &len, f) < 0)
		{
			break;
		}

		//printf("%s\n",tmpstr);
		/* comment */
		if (strstr(tmpstr, "#") != NULL)
		{
			fputs (tmpstr, ft);
			continue;
		}

		memset(major, '\0', 20);
		sscanf(tmpstr, "%s", major);

		if (strstr(major, "ttymajor") != NULL)
		{
			ttymajor = atoi(strstr(major, "=")+1);
			fputs (tmpstr, ft);
			continue;
		}

		if (strstr(major, "calloutmajor") != NULL )
		{
			calloutmajor = atoi(strstr(major, "=")+1);
			fputs (tmpstr, ft);
			continue;
		}

		concate(ip, "\t", tmp1);
		concate(ip, " ", tmp2);

		if (strstr(tmpstr, tmp1) != NULL || strstr(tmpstr, tmp2) != NULL)
		{
			if (overwrite == -1)
			{
				printf("The remote server ip is exist, \nare you sure to overwrite the settings [y/N]? ");
				scanf("%c", &c);

				if (c != 'Y' && c != 'y')
				{
					overwrite = -2;
				}
				else
				{
					overwrite = 1;
				}
			}
		}
		else
		{
			fputs (tmpstr, ft);
		}

		/* gather info (minor, ttyname, callout) */
		sscanf(tmpstr, "%s%s%s%s%s%s%s%s", tmpm, tmpt, tmpt, tmpt, tmpt, tmpt, tmpt, tmpc);

		sprintf(tmptty, "%s[%s]", tmptty, tmpt);
		sprintf(tmpcout, "%s[%s]", tmpcout, tmpc);
		minor[idx] = atoi(tmpm);
		idx++;
	}
	
	fclose(ft);
	fclose(f);

	total = atoi(argv[2]);

	if(total > 8)
	{
    		total = 8;
	}

	if ((idx + total) > 256)
	{
		printf("The number of installed port over range(maxinum 256).\n\n");
		
		free(tmpstr);
		free(tmp1);
		free(tmp2);
		free(tmptty);
		free(tmpcout);
		return 0;
	}

	if (overwrite == -2)
	{
		printf("\n");
		free(tmpstr);
		free(tmp1);
		free(tmp2);
		free(tmptty);
		free(tmpcout);
		return 0;
	}

	sprintf(tmpstr, "cp -f /tmp/ixvcom_tmpfile2 %s/ixvcomd.cf", VCOMPATH);
	system(tmpstr);
	system("rm -f /tmp/ixvcom_tmpfile2");

	sprintf(tmpstr, "%s/ixvcomd.cf", VCOMPATH);

	f = fopen (tmpstr, "a+");

	if (f == NULL)
	{
		printf("Opening configuration file error...\n");
		free(tmpstr);
		free(tmp1);
		free(tmp2);
		free(tmptty);
		free(tmpcout);
		return(0);
	}

	fifo = 1;
	ssl = 0;
	memset(tmpstr, 0, sizeof(tmpstr));

	for (i=0; i<total; i++)
	{
		mn = getMinor();
		sprintf(tmpt, "ttyVCOM%d", mn);
		sprintf(tmpc, "ttyVCOM%d", mn);
		printf("%s, %s\n", tmpt, tmpc);

		sprintf (tmpstr, "%d\t%s\t%d\t%d\t%d\t%d\t%s\t%s\t%s\n", mn, ip, dataport+i, cmdport, fifo, ssl, tmpt, tmpc, scope_id_s);

		fputs (tmpstr, f);
	}

	fclose(f);
	
	/* stop daemon (ixvcomd) */
	//printf("XXX stop ixvomd XXX\n");
	
	sprintf(tmpstr, "ps -ef | grep ixvcomd |");
	sprintf(tmpstr, "%s awk '$0 !~ /grep/ {system(\"kill -9 \"$2)}'", tmpstr);
	system(tmpstr);
	
	/* start daemon (ixvcomd) */
	//printf("XXX start ixvomd XXX\n");
	
	sprintf(tmpstr, "`pwd`/../daemon/ixvcomd");	
	system(tmpstr);
	

	free(tmpstr);
	free(tmp1);
	free(tmp2);
	free(tmptty);
	free(tmpcout);

	return 0;
}


