#include "utility.h"
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <stdlib.h>

char svrList[256][50];
int total[256];
int idx;

int check_usage(int arg, char *argv[])
{
	if (arg > 2)
	{
		printf("delserver [ip]\n\n");
		return FAILURE;
	}

	return SUCCESS;
}

char* GetIP(unsigned long ip, char *ret)
{
	struct in_addr ad;

	ad.s_addr = ip;
	sprintf(ret, "%s", inet_ntoa(ad));

	return;
}

int main(int arg, char *argv[])
{
	int i, j;
	int len, daemon;
	struct in_addr ad;
	char *tmpstr, *tmp, *os, c[5];
	char token[50], tty[20], cout[20], major[20], del[50];
	FILE *f, *ft;

	if (check_usage(arg, argv) != 0)
	{
		return 0;
	}

	system("clear");
	printf("\nDelete Remote Server ...\n");

	idx = 0;
	daemon = 0;
	tmpstr = (char *)malloc(1024);
	len = 1024;
	tmp = (char *)malloc(20);

	if (arg == 2)
	{
		sprintf(del, "%s", argv[1]);
		sprintf(tmpstr, "%s/ixvcomd.cf", VCOMPATH);

		f = fopen (tmpstr, "r");

		if (f == NULL)
		{
			printf("file open error\n");
			free(tmpstr);
			free(tmp);
			return SUCCESS;
		}

		/* search the del server */
		for (;;)
		{
			if (getline (&tmpstr, &len, f) < 0)
			{
				break;
			}

			if (strstr(tmpstr, "#") != NULL)
			{
				continue;
			}

			memset(major, '\0', 20);
			sscanf(tmpstr, "%s", major);

			if (strstr(major, "ttymajor") != NULL || strstr(major, "calloutmajor") != NULL )
			{
				continue;
			}

			sscanf(tmpstr, "%s%s", token, token);

			if (strcmp(token, del) == 0)
			{
				idx = 1;
				break;
			}
		}

		fclose (f);

		if (idx == 0)
		{
			printf("The speicified ip is not installed.\n\n");
			free(tmpstr);
			free(tmp);
			return 0;
		}
	}
	else
	{
		memset(svrList, 0x0, 256*50);
		memset(total, 0x0, 256*sizeof(int));

		sprintf(tmpstr, "%s/ixvcomd.cf", VCOMPATH);

		f = fopen (tmpstr, "r");

		if (f == NULL)
		{
			printf("file open error\n");
			free(tmpstr);
			free(tmp);
			return SUCCESS;
		}

		/* print the list of installed server */
		for (;;)
		{
			if (getline (&tmpstr, &len, f) < 0)
			{
				break;
			}

			if (strstr(tmpstr, "#") != NULL)
			{
				continue;
			}

			memset(major, '\0', 20);
			sscanf(tmpstr, "%s", major);

			if (strstr(major, "ttymajor") != NULL || strstr(major, "calloutmajor") != NULL )
			{
				continue;
			}

			sscanf(tmpstr, "%s%s", token, token);

			for (i=0; i<idx; i++)
			{
				if (!strcmp(svrList[i],token))
				{
					total[i]++;
					break;
				}
			}

			if (i == idx)
			{
				strcpy(svrList[idx], token);
				total[idx]++;
				idx++;
			}
		}

		fclose (f);

		if (idx == 0)
		{
			printf("No Remote server is installed.\n\n");
			free(tmpstr);
			free(tmp);
			return SUCCESS;
		}

		printf("\n[Index]\t%-40s\t[Port(s)]\n", "[Server IP]");

		for (i=0; i<idx; i++)
		{
			//    	    ad.s_addr = svrList[i];
			printf("  (%d)\t%-40s\t  %d\n", i+1, svrList[i], total[i]);
		}

		printf("  (q)\tExit\n");
		printf("\nSelect: ");
		scanf("%s", c);

		if (atoi(c)<=0 || atoi(c)>idx)
		{
			printf("Please run delserver again!!\n\n");
			free(tmpstr);
			free(tmp);
			return SUCCESS;
		}

		memset(tmp, '\0', 20);
		strcpy(del, svrList[atoi(c)-1]);
	}

	sprintf(tmpstr, "%s/ixvcomd.cf", VCOMPATH);

	f = fopen (tmpstr, "r");

	if (f == NULL)
	{
		printf("file open error\n");
		free(tmpstr);
		free(tmp);
		return SUCCESS;
	}

	ft = fopen ("/tmp/ixvcomtmp_cf", "w");

	if (ft == NULL)
	{
		printf("file open error\n");
		free(tmpstr);
		free(tmp);
		return SUCCESS;
	}

	/* Delete the server selected by user,  */
	/* and remove the relevant device files */

	for (;;)
	{
		if (getline (&tmpstr, &len, f) < 0)
		{
			break;
		}

		if (strstr(tmpstr, "#") != NULL)
		{
			fputs (tmpstr, ft);
			continue;
		}

		memset(major, '\0', 20);
		sscanf(tmpstr, "%s", major);
		if (strstr(major, "ttymajor") != NULL || strstr(major, "calloutmajor") != NULL )
		{
			fputs (tmpstr, ft);
			continue;
		}

		sscanf(tmpstr, "%s%s", token, token);

		if (strcmp(token, del) != 0)
		{
			fputs (tmpstr, ft);

			daemon = 1;
		}
	}

	fclose(ft);
	fclose (f);

	os = "linux";

	f = fopen ("/etc/redhat-release", "r");

	if (f != NULL)
	{
		fclose(f);
		os = "linux";
	}
	else
	{
        	f = fopen ("/etc/SuSE-release", "r");

	        if (f != NULL)
        	{
			fclose(f);
			os = "SuSE";
		}
		else
		{
			f = fopen ("/etc/debian_version", "r");

			if (f != NULL)
			{
				os = "debian";
			}
		}
	}

	sprintf(tmpstr, "cp -f /tmp/ixvcomtmp_cf %s/ixvcomd.cf", VCOMPATH);
	system(tmpstr);
	system("rm -f /tmp/ixvcomtmp_cf");

	/* stop daemon (ixvcomd) */
        sprintf(tmpstr, "ps -ef | grep ixvcomd |");
        sprintf(tmpstr, "%s awk '$0 !~ /grep/ {system(\"kill -9 \"$2)}'", tmpstr);
        system(tmpstr);

        /* start daemon (ixvcomd) */
        sprintf(tmpstr, "`pwd`/../daemon/ixvcomd");
        system(tmpstr);

	free(tmpstr);
	free(tmp);
	return 0;
}


